﻿import zmq
import json

class Node():
    def __init__(self):
        self.socks = []
        self.ctx = zmq.Context()

    def init_server(self, port):
        self.server_sock = self.ctx.socket(zmq.REQ)
        self.server_sock.bind('tcp://*:%s' % port)

    def connect_node(self, other_port):
        self.client_sock = self.ctx.socket(zmq.REP)
        self.client_sock.connect('tcp://localhost:%s' % other_port)

    def send_server(self, data):
        msg = json.dumps(data, separators=(',', ':'))
        self.server_sock.send_string(msg)

    def send_client(self, data):
        msg = json.dumps(data, separators=(',', ':'))
        self.client_sock.send_string(msg)

    def recv_server(self):
        return self.server_sock.recv()

    def recv_clinet(self):
        return self.client_sock.recv()