from socket import *
import threading
import time
from datetime import datetime
import json
import random
import hashlib
from bc import Blockchain
import pickle

import sys
from PyQt5 import QtCore, QtGui, QtWidgets

f1=""

class Ui_Main_F(object):
    def setupUi(self, Main_F):
        Main_F.setObjectName("Main_F")
        Main_F.resize(969, 678)
        Main_F.setStyleSheet("background-color: rgb(255,254,239);")
        Main_F.setSizeGripEnabled(False)
        self.label = QtWidgets.QLabel(Main_F)
        self.label.setGeometry(QtCore.QRect(0, 0, 969, 51))
        font = QtGui.QFont()
        font.setFamily("맑은 고딕")
        font.setPointSize(16)
        font.setBold(True)
        font.setWeight(75)
        self.label.setFont(font)
        self.label.setStyleSheet("background-color: rgb(170, 0, 0);")
        self.label.setFrameShape(QtWidgets.QFrame.NoFrame)
        self.label.setObjectName("label")
        self.plainTextEdit = QtWidgets.QPlainTextEdit(Main_F)
        self.plainTextEdit.setGeometry(QtCore.QRect(30, 130, 901, 501))
        font = QtGui.QFont()
        font.setFamily("맑은 고딕")
        font.setPointSize(14)
        self.plainTextEdit.setFont(font)
        self.plainTextEdit.setFocusPolicy(QtCore.Qt.NoFocus)
        self.plainTextEdit.setStyleSheet("background-color: rgb(255, 255, 255);\n"
"border: 3px solid #002060;")
        self.plainTextEdit.setReadOnly(True)
        self.plainTextEdit.setObjectName("plainTextEdit")

        self.retranslateUi(Main_F)
        QtCore.QMetaObject.connectSlotsByName(Main_F)

    def retranslateUi(self, Main_F):
        _translate = QtCore.QCoreApplication.translate
        Main_F.setWindowTitle(_translate("Main_F", "GUI CP"))
        Main_F.setToolTip(_translate("Main_F", "<html><head/><body><p>hi</p><p><br/></p></body></html>"))
        Main_F.setWhatsThis(_translate("Main_F", "<html><head/><body><p>h</p></body></html>"))
        self.label.setText(_translate("Main_F", "<html><head/><body><p align=\"center\"><span style=\" color:#ffffff;\">Well-Made</span></p></body></html>"))
        self.plainTextEdit.setPlainText(_translate("Main_F", "Check Point"))

    def settext(self, str_):
        self.plainTextEdit.appendPlainText(str_)

app = QtWidgets.QApplication(sys.argv)
Main_F = QtWidgets.QDialog()
ui = Ui_Main_F()
ui.setupUi(Main_F)
Main_F.show()

class Node():
    def __init__(self, host, port):
        self.host = host
        self.port = int(port)
        self.nodes = []

    def __debug(self, msg):
        global ui
        ui.settext('[%s] %s' % (str(threading.currentThread().getName()), msg))
        
    def __debug_server(self, msg):
        ui.settext('[출입문 서버] %s\n' % (msg))

    def __debug_client(self,msg):
        th_name = str(threading.currentThread().getName())
        if th_name =='MainThread':
            ui.settext('[출입문-첫번째 중간인증기관(ICA1) 연결] %s\n' %(msg))
        elif th_name =='Thread-1':
            ui.settext('[첫번째 중간인증기관(ICA1) 수신] %s\n' %(msg))
        elif th_name =='Thread-2':
            ui.settext('[출입문 발신] %s\n' %(msg))
        elif th_name == 'Thread-3':
            ui.settext('[출입문 발신] %s\n' %(msg))            
        else:
            ui.settext('[출입문 서버] %s \n' %(msg))
            
    def scanning(self, s):  # 얼굴 인식
        time.sleep(45)
        while True:
            self.__send(s, {'type':'face', 'data': f1[0], 'passfail': f1[1], 'time': f1[2]})
          #  self.__debug_client('생체정보 전송완료\n')
            ui.settext('[출입문 서버] 생체 정보 전송\n')
            time.sleep(5)


    def scanning_(self, s):  # 얼굴 인식
        while True:
        #for x in range(3):
            self.__send(s, {"type":"face", "data":"user1111"})
            self.__debug_client('생체정보 전송완료\n')
            time.sleep(5)

            
    def run_server(self):
        self.s = socket(AF_INET, SOCK_STREAM)
        self.s.bind((self.host, self.port))
        self.s.listen(5)

        self.__debug_server('서버 실행 (%d)\n' % self.port)
        #time.sleep(10)
        recv_count =0   
        while True:
            self.__debug_server('연결대기 ... ')
            client_sock, client_addr = self.s.accept()
            self.nodes.append(client_sock)
            self.__debug_server('연결됨' + str(self.nodes[-1].getpeername()))

            r_recv = threading.Thread(target = self.recv, args={self.nodes[-1]})
            r_recv.start()
 

    def run_client(self, host, port):   # run_client(host, port) -> 소켓 연결
        s = socket(AF_INET, SOCK_STREAM)
        s.connect((host, int(port)))
       # self.__debug_client('연결됨' + str(s.getpeername()))
        ui.settext('[출입문-첫번째 중간인증기관(ICA1) 연결]'+str(s.getpeername())+"\n")
        return s

    def __send(self, s, data):  # __send(socket, data) -> 데이터 전송
        #msg = json.dumps(data, separators=(',', ':')).encode('utf-8')
        msg = pickle.dumps(data)
        s.sendall(msg)


    def recv(self, s):
        #self.__debug_client('연결완료. 데이터 수신 대기중 ... \n')
        ui.settext('[출입문 서버] 데이터 수신 대기중 ... \n')
        global block
        global times
        global checkpoint
        times = 0
        tran_data = block.current_transactions[-1]
        while True:

            msg = s.recv(1024)
            data = pickle.loads(msg)
            #data = json.loads(msg)
            if data:
               # self.__debug_client('받은정보 : ' + str(data))
                if(data.get('type') == 'passfail'):
                    time_ = times
                    block.new_transaction(tran_data['number']+1, data.get('user'), checkpoint, data.get('time'), data.get('passfail'))
                    
                    times = data.get('time')
                    if (data.get('passfail')=='True'):
                        #self.__debug_client("출입허가")
                        ui.settext("[출입문 서버] 출입 허가\n")
                    elif(data.get('passfail')=='False'):
                        #self.__debug_client("출입불허. 사용자를 등록해주세요.")
                        ui.settext("[출입문 서버] 출입 불허. 사용자를 등록해주세요.\n")
                    if (times ==time_):
                        #self.__debug_client("동일한 시간대 출입기록. 대기")
                        ui.settext("[출입문 서버] 동일한 시간대의 출입기록. 대기중 ... \n")
                    else:  
                        tran_data = block.current_transactions[-1]
                        self.__send(s, tran_data)
                        #self.__debug_client("트랜잭션 생성완료. 중간 인증서버로 전송(ICA1)")
                        ui.settext("[출입문 서버] 트랜잭션 생성완료. 중간 인증서버로 전송(ICA1) \n")

                if(data.get('type') =='face'):
                    f = str(data['data'])
                    global f1
                    f1 = f.split(",")
                    self.__send(s, {'type' : 'r_face', 'data' : "전송완료"})

                if(data.get('type')=='new_face'):
                    self.__send(cp_s, {'type':'new_name', 'data':data.get('data')})
                    #self.__debug_client('new face')
                     ui.settext("[출입문 서버] 새로운 사용자 정보 전송\n")
def hi():
    global ui
    global block
    global checkpoint
    
    checkpoint = 'checkpoint1'
    host = 'localhost'
    port = int(1234)

    

    block_data = block.new_block(1,1,1,1)
    create_tran = block.new_transaction(1, 'user1', 'checkpoint1', 1, 1)

    tran_data = block.current_transactions[-1]

    cp = Node(host, port)
    cp_s = cp.run_client('localhost', 2000)

    t_recv = threading.Thread(target = cp.recv, args={cp_s})
    t_recv.start()
    t_scanning = threading.Thread(target = cp.scanning, args={cp_s})
    t_scanning.start()

    cp.run_server()
    
checkpoint =""

block = Blockchain() 
thrd = threading.Thread(target = hi, args={})
thrd.start()
app.exec_()
